package models

import "encoding/xml"

type ReportResultEnvelope struct {
	XMLName xml.Name         `xml:"soap:Envelope"`
	Soap    string           `xml:"xmlns:soap,attr"`
	Xsi     string           `xml:"xmlns:xsi,attr"`
	Xsd     string           `xml:"xmlns:xsd,attr"`
	Body    ReportResultBody `xml:"soap:Body"`
}

type ReportResultBody struct {
	XMLName            xml.Name           `xml:"soap:Body"`
	GetReportResultReq GetReportResultReq `xml:"GetJSONReportItemListByCustomerBarocde"`
}

type GetReportResultReq struct {
	XMLName         xml.Name `xml:"http://tempuri.org/ GetJSONReportItemListByCustomerBarocde"`
	Key             string   `xml:"key"`
	CustomerBarCode string   `xml:"CustomerBarCode"`
}

type EnvelopeThree struct {
	XMLName xml.Name          `xml:"http://schemas.xmlsoap.org/soap/envelope/ Envelope"`
	Body    EnvelopeBodyThree `xml:"Body"`
}

type EnvelopeBodyThree struct {
	GetJSONReportItemListByCustomerBarocdeResponse GetJSONReportItemListByCustomerBarocdeResponse `xml:"GetJSONReportItemListByCustomerBarocdeResponse"`
}

type GetJSONReportItemListByCustomerBarocdeResponse struct {
	XMLName                                      xml.Name `xml:"http://tempuri.org/ GetJSONReportItemListByCustomerBarocdeResponse"`
	GetJSONReportItemListByCustomerBarocdeResult string   `xml:"GetJSONReportItemListByCustomerBarocdeResult"`
}

type ReportResultData struct {
	Res           int             `json:"Res"`
	Error         string          `json:"Error"`
	InspectResult []InspectResult `json:"Data"`
}

type InspectResult struct {
	ChargeItemName string `json:"ChargeItemName"`
	InspectionName string `json:"InspectionName"`
	InspectionCode string `json:"InspectionCode"`
	Result         string `json:"Result"`
	Reference      string `json:"Reference"`
	Barcode        string `json:"Barcode"`
	Unit           string `json:"Unit"`
	Flag           string `json:"Flag"`
	intFlag        int    `json:"intFlag"`
	ListResult     GPReportListResultData
}

type DataPrintCode struct {
	ID          int64  `gorm:"column:id" json:"id" form:"id"`
	HisUserId   string `gorm:"column:his_user_id" json:"his_user_id" form:"his_user_id"`
	Name        string `gorm:"column:name" json:"name" form:"name"`
	RecordDate  int64  `gorm:"column:record_date" json:"record_date" form:"record_date"`
	ProjectName string `gorm:"column:project_name" json:"project_name" form:"project_name"`
	Ctime       int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime       int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status      int64  `gorm:"column:status" json:"status" form:"status"`
	PrintId     int64  `gorm:"column:print_id" json:"print_id" form:"print_id"`
	PatientId   int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
}

func (DataPrintCode) TableName() string {
	return "print_code"
}

type XtHisLabelPrintStatusInfo struct {
	ID                 int64  `gorm:"column:id" json:"id" form:"id"`
	PatientId          int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	Ctime              int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime              int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status             int64  `gorm:"column:status" json:"status" form:"status"`
	IsCombinationPrint int64  `gorm:"column:is_combination_print" json:"is_combination_print" form:"is_combination_print"`
	RecordDate         string `gorm:"column:record_date" json:"record_date" form:"record_date"`
	ItemIds            string `gorm:"column:item_ids" json:"item_ids" form:"item_ids"`
	UserOrgId          int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	ProjectIds         string `gorm:"column:project_ids" json:"project_ids" form:"project_ids"`
	DoctorId           int64  `gorm:"column:doctor_id" json:"doctor_id" form:"doctor_id"`
	Ids                string `gorm:"column:ids" json:"ids" form:"ids"`
	IsTeam             int64  `gorm:"column:is_team" json:"is_team" form:"is_team"`
	IsPrint            int64  `gorm:"column:is_print" json:"is_print" form:"is_print"`
	ApplyCode          string `gorm:"column:apply_code" json:"apply_code" form:"apply_code"`
}

func (XtHisLabelPrintStatusInfo) TableName() string {
	return "his_label_print_status_info"
}

type HisLabelPrintInfo struct {
	ID             int64  `gorm:"column:id" json:"id" form:"id"`
	PatientId      int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	Number         string `gorm:"column:number" json:"number" form:"number"`
	Ctime          int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime          int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	DoctorId       int64  `gorm:"column:doctor_id" json:"doctor_id" form:"doctor_id"`
	Status         int64  `gorm:"column:status" json:"status" form:"status"`
	ProjectName    string `gorm:"column:project_name" json:"project_name" form:"project_name"`
	ProjectId      int64  `gorm:"column:project_id" json:"project_id" form:"project_id"`
	IsPrint        int64  `gorm:"column:is_print" json:"is_print" form:"is_print"`
	RecordDate     int64  `gorm:"column:record_date" json:"record_date" form:"record_date"`
	ItemId         int64  `gorm:"column:item_id" json:"item_id" form:"item_id"`
	PProjectId     int64  `gorm:"column:p_project_id" json:"p_project_id" form:"p_project_id"`
	UserOrgId      int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	DoctorName     string `gorm:"column:doctor_name" json:"doctor_name" form:"doctor_name"`
	PatientName    string `gorm:"column:patient_name" json:"patient_name" form:"patient_name"`
	FeedetlSn      string `gorm:"column:feedetl_sn" json:"feedetl_sn" form:"feedetl_sn"`
	PrescriptionId int64  `gorm:"column:prescription_id" json:"prescription_id" form:"prescription_id"`
	ApplyCode      string `gorm:"column:apply_code" json:"apply_code" form:"apply_code"`
}

func (HisLabelPrintInfo) TableName() string {
	return "his_label_print_info"
}

type XtHisProjectTeam struct {
	ID          int64   `gorm:"column:id" json:"id" form:"id"`
	ProjectTeam string  `gorm:"column:project_team" json:"project_team" form:"project_team"`
	Price       float64 `gorm:"column:price" json:"price" form:"price"`
	Pinyin      string  `gorm:"column:pinyin" json:"pinyin" form:"pinyin"`
	Wubi        string  `gorm:"column:wubi" json:"wubi" form:"wubi"`
	TubeColor   int64   `gorm:"column:tube_color" json:"tube_color" form:"tube_color"`
	TeamType    int64   `gorm:"column:team_type" json:"team_type" form:"team_type"`
	Remark      string  `gorm:"column:remark" json:"remark" form:"remark"`
	UserOrgId   int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status      int64   `gorm:"column:status" json:"status" form:"status"`
	CreatedTime int64   `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime int64   `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	ProjectId   string  `gorm:"column:project_id" json:"project_id" form:"project_id"`
	ItemId      string  `gorm:"column:item_id" json:"item_id" form:"item_id"`
	Sort        int64   `gorm:"column:sort" json:"sort" form:"sort"`
}

func (XtHisProjectTeam) TableName() string {
	return "xt_his_project_team"
}

type XtHisProjectList struct {
	ID           int64        `gorm:"column:id" json:"id" form:"id"`
	Number       int64        `gorm:"column:number" json:"number" form:"number"`
	UserOrgId    int64        `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	ProjectId    int64        `gorm:"column:project_id" json:"project_id" form:"project_id"`
	Status       int64        `gorm:"column:status" json:"status" form:"status"`
	CreatedTime  int64        `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime  int64        `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	TeamId       int64        `gorm:"column:team_id" json:"team_id" form:"team_id"`
	Type         int64        `gorm:"column:type" json:"type" form:"type"`
	XtHisProject XtHisProject `gorm:"ForeignKey:ID;AssociationForeignKey:ProjectId" json:"project"`
	PN           string       `gorm:"-" json:"pn" form:"pn"`
}

func (XtHisProjectList) TableName() string {
	return "xt_his_project_list"
}

type XtHisProject struct {
	ID                          int64   `gorm:"column:id" json:"id" form:"id"`
	ProjectName                 string  `gorm:"column:project_name" json:"project_name" form:"project_name"`
	Pinyin                      string  `gorm:"column:pinyin" json:"pinyin" form:"pinyin"`
	Wubi                        string  `gorm:"column:wubi" json:"wubi" form:"wubi"`
	Price                       float64 `gorm:"column:price" json:"price" form:"price"`
	Unit                        string  `gorm:"column:unit" json:"unit" form:"unit"`
	CostClassify                int64   `gorm:"column:cost_classify" json:"cost_classify" form:"cost_classify"`
	ExecutiveSection            int64   `gorm:"column:executive_section" json:"executive_section" form:"executive_section"`
	MedicalCoverage             int64   `gorm:"column:medical_coverage" json:"medical_coverage" form:"medical_coverage"`
	StatisticalClassification   int64   `gorm:"column:statistical_classification" json:"statistical_classification" form:"statistical_classification"`
	DiseaseDirectory            int64   `gorm:"column:disease_directory" json:"disease_directory" form:"disease_directory"`
	IsRecord                    int64   `gorm:"column:is_record" json:"is_record" form:"is_record"`
	MedicalCode                 string  `gorm:"column:medical_code" json:"medical_code" form:"medical_code"`
	TubeColor                   int64   `gorm:"column:tube_color" json:"tube_color" form:"tube_color"`
	MedicalStatus               int64   `gorm:"column:medical_status" json:"medical_status" form:"medical_status"`
	Remark                      string  `gorm:"column:remark" json:"remark" form:"remark"`
	Sign                        int64   `gorm:"column:sign" json:"sign" form:"sign"`
	DefaultNumber               string  `gorm:"column:default_number" json:"default_number" form:"default_number"`
	IsDefault                   int64   `gorm:"column:is_default" json:"is_default" form:"is_default"`
	IsCharge                    int64   `gorm:"column:is_charge" json:"is_charge" form:"is_charge"`
	IsEstimate                  int64   `gorm:"column:is_estimate" json:"is_estimate" form:"is_estimate"`
	IsWorkload                  int64   `gorm:"column:is_workload" json:"is_workload" form:"is_workload"`
	Sort                        string  `gorm:"column:sort" json:"sort" form:"sort"`
	DoctorAdvice                int64   `gorm:"column:doctor_advice" json:"doctor_advice" form:"doctor_advice"`
	UserOrgId                   int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status                      int64   `gorm:"column:status" json:"status" form:"status"`
	CreatedTime                 int64   `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime                 int64   `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	SingleDose                  string  `gorm:"column:single_dose" json:"single_dose" form:"single_dose"`
	ExecutionFrequency          string  `gorm:"column:execution_frequency" json:"execution_frequency" form:"execution_frequency"`
	DeliveryWay                 string  `gorm:"column:delivery_way" json:"delivery_way" form:"delivery_way"`
	NumberDays                  string  `gorm:"column:number_days" json:"number_days" form:"number_days"`
	Total                       string  `gorm:"column:total" json:"total" form:"total"`
	Category                    int64   `gorm:"column:category" json:"category" form:"category"`
	IsMark                      int64   `gorm:"column:is_mark" json:"is_mark" form:"is_mark"`
	SpecailProject              int64   `gorm:"column:specail_project" json:"specail_project" form:"specail_project"`
	SocialSecurityDirectoryCode string  `gorm:"column:social_security_directory_code" json:"social_security_directory_code" form:"social_security_directory_code"`
	RecordDate                  int64   `gorm:"column:record_date" json:"record_date" form:"record_date"`
	IsPrint                     int64   `gorm:"column:is_print" json:"is_print" form:"is_print"`
	FirstLetter                 string  `gorm:"column:first_letter" json:"first_letter" form:"first_letter"`
	Bbx01                       string  `gorm:"column:bbx01" json:"bbx01" form:"bbx01"`
	Bby01                       string  `gorm:"column:bby01" json:"bby01" form:"bby01"`
	ZuobiaoId                   string  `gorm:"column:zuobiao_id" json:"zuobiao_id" form:"zuobiao_id"`
}

func (XtHisProject) TableName() string {
	return "xt_his_project"
}
